package org.kaoriha.jspbp.taglib;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;

import org.apache.commons.beanutils.PropertyUtils;

public abstract class GlobalAttr {
	private String id;
	private String cssClass;
	private String style;
	private String title;
	private String lang;
	private String dir;
	private String onclick;
	private String ondblclick;
	private String onmousedown;
	private String onmouseup;
	private String onmousemove;
	private String onmouseout;
	private String onkeypress;
	private String onkeydown;
	private String onkeyup;
	private String accesskey;
	private String tabindex;
	private String onfocus;
	private String onblur;

	private String property;

	protected abstract void printPropertyAttr(PageContext pageContext,
			String name, Object value) throws IOException, JspException;

	@SuppressWarnings("unchecked")
	protected void printAttrs(PageContext pageContext)
			throws IllegalAccessException, InvocationTargetException,
			NoSuchMethodException, IOException, JspException {
		for (Object o : PropertyUtils.describe(this).entrySet()) {
			Map.Entry<String, Object> entry = (Map.Entry<String, Object>) o;
			if (!(entry.getValue() instanceof String)) {
				continue;
			}
			if (entry.getKey().equals("propertyValue")) {
				continue;
			}
			if (entry.getKey().equals("property")) {
				HttpServletRequest request = (HttpServletRequest) pageContext
				.getRequest();
				Object behind = request.getAttribute("behind");
				Object p = PropertyUtils.getSimpleProperty(behind, (String) entry.getValue());
				printPropertyAttr(pageContext, (String) entry.getValue(), p);
				continue;
			}
			if (entry.getKey().equals("cssClass")) {
				pageContext.getOut().print("class=\"");
				pageContext.getOut().print(entry.getValue());
				pageContext.getOut().print("\" ");
				continue;
			}
			pageContext.getOut().print(entry.getKey());
			pageContext.getOut().print("=\"");
			pageContext.getOut().print(entry.getValue());
			pageContext.getOut().print("\" ");

			if (entry.getKey().equals("lang")) {
				pageContext.getOut().print("xml:lang=\"");
				pageContext.getOut().print(entry.getValue());
				pageContext.getOut().print("\" ");
				continue;
			}
		}
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getCssClass() {
		return cssClass;
	}

	public void setCssClass(String cssClass) {
		this.cssClass = cssClass;
	}

	public String getStyle() {
		return style;
	}

	public void setStyle(String style) {
		this.style = style;
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getLang() {
		return lang;
	}

	public void setLang(String lang) {
		this.lang = lang;
	}

	public String getDir() {
		return dir;
	}

	public void setDir(String dir) {
		this.dir = dir;
	}

	public String getOnclick() {
		return onclick;
	}

	public void setOnclick(String onclick) {
		this.onclick = onclick;
	}

	public String getOndblclick() {
		return ondblclick;
	}

	public void setOndblclick(String ondblclick) {
		this.ondblclick = ondblclick;
	}

	public String getOnmousedown() {
		return onmousedown;
	}

	public void setOnmousedown(String onmousedown) {
		this.onmousedown = onmousedown;
	}

	public String getOnmouseup() {
		return onmouseup;
	}

	public void setOnmouseup(String onmouseup) {
		this.onmouseup = onmouseup;
	}

	public String getOnmousemove() {
		return onmousemove;
	}

	public void setOnmousemove(String onmousemove) {
		this.onmousemove = onmousemove;
	}

	public String getOnmouseout() {
		return onmouseout;
	}

	public void setOnmouseout(String onmouseout) {
		this.onmouseout = onmouseout;
	}

	public String getOnkeypress() {
		return onkeypress;
	}

	public void setOnkeypress(String onkeypress) {
		this.onkeypress = onkeypress;
	}

	public String getOnkeydown() {
		return onkeydown;
	}

	public void setOnkeydown(String onkeydown) {
		this.onkeydown = onkeydown;
	}

	public String getOnkeyup() {
		return onkeyup;
	}

	public void setOnkeyup(String onkeyup) {
		this.onkeyup = onkeyup;
	}

	public String getAccesskey() {
		return accesskey;
	}

	public void setAccesskey(String accesskey) {
		this.accesskey = accesskey;
	}

	public String getTabindex() {
		return tabindex;
	}

	public void setTabindex(String tabindex) {
		this.tabindex = tabindex;
	}

	public String getOnfocus() {
		return onfocus;
	}

	public void setOnfocus(String onfocus) {
		this.onfocus = onfocus;
	}

	public String getOnblur() {
		return onblur;
	}

	public void setOnblur(String onblur) {
		this.onblur = onblur;
	}

	public String getProperty() {
		return property;
	}

	public void setProperty(String property) {
		this.property = property;
	}
}
