package org.kaoriha.jspbp.taglib;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;

import org.apache.commons.lang.StringEscapeUtils;
import org.kaoriha.jspbp.Constant;

public class InputTagAttr extends GlobalAttr {

	private String type;
	private String checked;
	private String disabled;
	private String readonly;
	private String size;
	private String maxlength;
	private String src;
	private String alt;
	private String usemap;
	private String onselect;
	private String onchange;
	private String accept;
	private String align;
	private String value;

	@Override
	protected void printPropertyAttr(PageContext pageContext, String name,
			Object value) throws IOException, JspException {
		pageContext.getOut().print("name");
		pageContext.getOut().print("=\"");
		pageContext.getOut().print(name);
		pageContext.getOut().print("\" ");

		if (type.equals("checkbox")) {
			if (this.value != null) {
				throw new JspException("type:" + type
						+ " cannot have 'value' attribute.");
			}
			if ((Boolean) value) {
				pageContext.getOut().print("checked=\"checked\" ");
			}
			pageContext.getOut().print("value=\"true\" ");
		} else if (type.equals("radio")) {
			if (this.value == null) {
				throw new JspException("type:" + type
						+ " requires 'value' attribute.");
			}
			if (this.value.equals(value)) {
				pageContext.getOut().print("checked=\"checked\" ");
			}
		} else if (type.equals("text") || type.equals("password")
				|| type.equals("hidden")) {
			if (this.value != null) {
				throw new JspException("type:" + type
						+ " cannot have 'value' attribute.");
			}
			pageContext.getOut().print("value=\"");
			if (value != null) {
				pageContext.getOut().print(
						StringEscapeUtils.escapeXml((String) value));
			}
			pageContext.getOut().print("\" ");
		}
	}

	public void doStartTag(PageContext pageContext) throws JspException,
			IOException, IllegalAccessException, InvocationTargetException,
			NoSuchMethodException {
		if (type.equals("checkbox")) {
			pageContext.getOut().print(
					"<input type=\"hidden\" name=\""
							+ Constant.CHECKBOX_NAME_QN + "\" value=\""
							+ getProperty() + "\" />");
		}
		pageContext.getOut().print("<input ");
		printAttrs(pageContext);
		pageContext.getOut().print("/>");
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getChecked() {
		return checked;
	}

	public void setChecked(String checked) {
		this.checked = checked;
	}

	public String getDisabled() {
		return disabled;
	}

	public void setDisabled(String disabled) {
		this.disabled = disabled;
	}

	public String getReadonly() {
		return readonly;
	}

	public void setReadonly(String readonly) {
		this.readonly = readonly;
	}

	public String getSize() {
		return size;
	}

	public void setSize(String size) {
		this.size = size;
	}

	public String getMaxlength() {
		return maxlength;
	}

	public void setMaxlength(String maxlength) {
		this.maxlength = maxlength;
	}

	public String getSrc() {
		return src;
	}

	public void setSrc(String src) {
		this.src = src;
	}

	public String getAlt() {
		return alt;
	}

	public void setAlt(String alt) {
		this.alt = alt;
	}

	public String getUsemap() {
		return usemap;
	}

	public void setUsemap(String usemap) {
		this.usemap = usemap;
	}

	public String getOnselect() {
		return onselect;
	}

	public void setOnselect(String onselect) {
		this.onselect = onselect;
	}

	public String getOnchange() {
		return onchange;
	}

	public void setOnchange(String onchange) {
		this.onchange = onchange;
	}

	public String getAccept() {
		return accept;
	}

	public void setAccept(String accept) {
		this.accept = accept;
	}

	public String getAlign() {
		return align;
	}

	public void setAlign(String align) {
		this.align = align;
	}

	public String getValue() {
		return value;
	}

	public void setValue(String value) {
		this.value = value;
	}
}
